diff -r 41a25660ece8 trytond/modules/account_statement/statement.py
--- a/trytond/modules/account_statement/statement.py	Wed Sep 19 22:19:04 2012 +0200
+++ b/trytond/modules/account_statement/statement.py	Mon Sep 24 20:36:39 2012 +0200
@@ -7,15 +7,15 @@
 from trytond.backend import TableHandler
 from trytond.pool import Pool
 
+__all__ = ['Statement', 'Line']
+
 _STATES = {'readonly': Eval('state') != 'draft'}
 _DEPENDS = ['state']
 
 
 class Statement(Workflow, ModelSQL, ModelView):
     'Account Statement'
-    _name = 'account.statement'
-    _description = __doc__
-
+    __name__ = 'account.statement'
     company = fields.Many2One('company.company', 'Company', required=True,
         select=True, states=_STATES, domain=[
             ('id', If(Eval('context', {}).contains('company'), '=', '!='),
@@ -33,7 +33,7 @@
         on_change=['journal', 'state', 'lines'], select=True,
         depends=['state', 'lines'])
     currency_digits = fields.Function(fields.Integer('Currency Digits',
-        on_change_with=['journal']), 'get_currency_digits')
+            on_change_with=['journal']), 'on_change_with_currency_digits')
     date = fields.Date('Date', required=True, states=_STATES, depends=_DEPENDS,
         select=True)
     start_balance = fields.Numeric('Start Balance', required=True,
@@ -47,7 +47,7 @@
             digits=(16, Eval('currency_digits', 2)),
             on_change_with=['start_balance', 'end_balance'],
             depends=['currency_digits']),
-        'get_balance')
+        'on_change_with_balance')
     lines = fields.One2Many('account.statement.line', 'statement',
         'Transactions', states={
             'readonly': (Eval('state') != 'draft') | ~Eval('journal'),
@@ -62,21 +62,22 @@
     move_lines = fields.Function(fields.One2Many('account.move.line',
         None, 'Move Lines'), 'get_move_lines')
 
-    def __init__(self):
-        super(Statement, self).__init__()
-        self._order[0] = ('id', 'DESC')
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(Statement, cls).__setup__()
+        cls._order[0] = ('id', 'DESC')
+        cls._error_messages.update({
                 'wrong_end_balance': 'End Balance must be %s!',
                 'delete_cancel': 'Statement "%s" must be cancelled before ' \
                     'deletion!',
                 })
-        self._transitions |= set((
+        cls._transitions |= set((
                 ('draft', 'validated'),
                 ('validated', 'posted'),
                 ('validated', 'cancel'),
                 ('cancel', 'draft'),
                 ))
-        self._buttons.update({
+        cls._buttons.update({
                 'draft': {
                     'invisible': Eval('state') != 'cancel',
                     },
@@ -91,259 +92,245 @@
                     },
                 })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
 
         # Migration from 1.8: new field company
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         company_exist = table.column_exist('company')
 
-        super(Statement, self).init(module_name)
+        super(Statement, cls).__register__(module_name)
 
         # Migration from 1.8: fill new field company
         if not company_exist:
             offset = 0
             limit = cursor.IN_MAX
-            statement_ids = True
-            while statement_ids:
-                statement_ids = self.search([], offset=offset, limit=limit)
+            statements = True
+            while statements:
+                statements = cls.search([], offset=offset, limit=limit)
                 offset += limit
-                for statement in self.browse(statement_ids):
-                    self.write(statement.id, {
-                        'company': statement.journal.company.id,
-                    })
-            table = TableHandler(cursor, self, module_name)
+                for statement in statements:
+                    cls.write([statement], {
+                            'company': statement.journal.company.id,
+                            })
+            table = TableHandler(cursor, cls, module_name)
             table.not_null_action('company', action='add')
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'draft'
 
-    def default_date(self):
-        date_obj = Pool().get('ir.date')
-        return date_obj.today()
+    @staticmethod
+    def default_date():
+        Date = Pool().get('ir.date')
+        return Date.today()
 
-    def default_currency_digits(self):
-        company_obj = Pool().get('company.company')
+    @staticmethod
+    def default_currency_digits():
+        Company = Pool().get('company.company')
         if Transaction().context.get('company'):
-            company = company_obj.browse(Transaction().context['company'])
+            company = Company(Transaction().context['company'])
             return company.currency.digits
         return 2
 
-    def on_change_journal(self, value):
+    def on_change_journal(self):
         res = {}
-        if not value.get('journal'):
+        if not self.journal:
             return res
 
-        statement_ids = self.search([
-            ('journal', '=', value['journal']),
-            ], order=[
+        statements = self.search([
+                ('journal', '=', self.journal.id),
+                ], order=[
                 ('date', 'DESC'),
-            ], limit=1)
-        if not statement_ids:
+                ], limit=1)
+        if not statements:
             return res
 
-        statement = self.browse(statement_ids[0])
+        statement, = statements
         res['start_balance'] = statement.end_balance
         return res
 
-    def on_change_with_currency_digits(self, vals):
-        journal_obj = Pool().get('account.statement.journal')
-        if vals.get('journal'):
-            journal = journal_obj.browse(vals['journal'])
-            return journal.currency.digits
+    def on_change_with_currency_digits(self, name=None):
+        if self.journal:
+            return self.journal.currency.digits
         return 2
 
-    def get_currency_digits(self, ids, name):
+    @classmethod
+    def get_rec_name(cls, statements, name):
+        Lang = Pool().get('ir.lang')
+
+        lang, = Lang.search([
+                ('code', '=', Transaction().language),
+                ])
+
         res = {}
-        for statement in self.browse(ids):
-            res[statement.id] = statement.journal.currency.digits
+        for statement in statements:
+            res[statement.id] = (statement.journal.name + ' '
+                + Lang.currency(lang, statement.start_balance,
+                    statement.journal.currency, symbol=False, grouping=True)
+                + Lang.currency(lang, statement.end_balance,
+                    statement.journal.currency, symbol=False, grouping=True))
         return res
 
-    def get_rec_name(self, ids, name):
-        lang_obj = Pool().get('ir.lang')
-
-        if not ids:
-            return {}
-
-        lang_id, = lang_obj.search([
-                ('code', '=', Transaction().language),
+    @classmethod
+    def search_rec_name(cls, name, clause):
+        statements = cls.search(['OR',
+                ('start_balance',) + tuple(clause[1:]),
+                ('end_balance',) + tuple(clause[1:]),
                 ])
-        lang = lang_obj.browse(lang_id)
-
-        res = {}
-        for statement in self.browse(ids):
-            res[statement.id] = statement.journal.name + ' ' + \
-                    lang.currency(lang, statement.start_balance,
-                        statement.journal.currency, symbol=False,
-                        grouping=True) + \
-                    lang.currency(lang, statement.end_balance,
-                        statement.journal.currency, symbol=False,
-                        grouping=True)
-        return res
-
-    def search_rec_name(self, name, clause):
-        ids = self.search(['OR',
-            ('start_balance',) + tuple(clause[1:]),
-            ('end_balance',) + tuple(clause[1:]),
-            ])
-        if ids:
-            return [('id', 'in', ids)]
+        if statements:
+            return [('id', 'in', [s.id for s in statements])]
         return [('journal',) + tuple(clause[1:])]
 
-    def get_move_lines(self, ids, name):
+    def get_move_lines(self, name):
         '''
-        Return the move lines that have been generated by the statements.
+        Return the move lines that have been generated by the statement.
         '''
-        res = {}
-        for statement in self.browse(ids):
-            res[statement.id] = []
-            for line in statement.lines:
-                if not line.move:
-                    continue
-                for move_line in line.move.lines:
-                    res[statement.id].append(move_line.id)
-        return res
+        move_lines = []
+        for line in self.lines:
+            if not line.move:
+                continue
+            for move_line in line.move.lines:
+                move_lines.append(move_line.id)
+        return move_lines
 
-    def get_end_balance(self, ids, name):
-        statements = self.browse(ids)
-        res = {}
-        for statement in statements:
-            res[statement.id] = statement.start_balance
-            for line in statement.lines:
-                res[statement.id] += line.amount
-        return res
+    def get_end_balance(self, name):
+        end_balance = self.start_balance
+        for line in self.lines:
+            end_balance += line.amount
+        return end_balance
 
-    def get_balance(self, ids, name):
-        return dict((s.id, s.end_balance - s.start_balance)
-            for s in self.browse(ids))
+    def on_change_with_balance(self, name=None):
+        return ((getattr(self, 'end_balance', 0) or 0)
+            - (getattr(self, 'start_balance', 0) or 0))
 
-    def on_change_with_balance(self, values):
-        if not set(('end_balance', 'start_balance')) <= set(values):
-            return Decimal(0)
-        else:
-            return Decimal(values.get('end_balance') or 0
-                - values.get('start_balance') or 0)
-
-    def on_change_lines(self, values):
+    def on_change_lines(self):
         pool = Pool()
-        invoice_obj = pool.get('account.invoice')
-        journal_obj = pool.get('account.statement.journal')
-        currency_obj = pool.get('currency.currency')
+        Currency = pool.get('currency.currency')
+        Line = pool.get('account.statement.line')
         res = {
             'lines': {},
-        }
-        if values.get('journal') and values.get('lines'):
-            journal = journal_obj.browse(values['journal'])
-            invoice_ids = set()
-            for line in values['lines']:
-                if line['invoice']:
-                    invoice_ids.add(line['invoice'])
+            }
+        if self.journal and self.lines:
+            invoices = set()
+            for line in self.lines:
+                if line.invoice:
+                    invoices.add(line.invoice)
             invoice_id2amount_to_pay = {}
-            for invoice in invoice_obj.browse(list(invoice_ids)):
+            for invoice in invoices:
                 with Transaction().set_context(date=invoice.currency_date):
                     invoice_id2amount_to_pay[invoice.id] = (
-                        currency_obj.compute(invoice.currency.id,
-                            invoice.amount_to_pay, journal.currency.id))
+                        Currency.compute(invoice.currency,
+                            invoice.amount_to_pay, self.journal.currency))
 
-            for line in values['lines']:
-                if line['invoice'] and line['id']:
-                    amount_to_pay = invoice_id2amount_to_pay[line['invoice']]
-                    if abs(line['amount']) > amount_to_pay:
+            for line in self.lines or []:
+                if line.invoice and line.id:
+                    amount_to_pay = invoice_id2amount_to_pay[line.invoice.id]
+                    if abs(line.amount) > amount_to_pay:
                         res['lines'].setdefault('update', [])
-                        if currency_obj.is_zero(journal.currency,
-                                amount_to_pay):
+                        if self.journal.currency.is_zero(amount_to_pay):
                             res['lines']['update'].append({
-                                'id': line['id'],
+                                'id': line.id,
                                 'invoice': None,
                                 })
                         else:
                             res['lines']['update'].append({
-                                'id': line['id'],
+                                'id': line.id,
                                 'amount': (amount_to_pay
-                                        if line['amount'] >= 0
+                                        if line.amount >= 0
                                         else -amount_to_pay),
                                 })
                             res['lines'].setdefault('add', [])
-                            vals = line.copy()
+                            vals = {}
+                            for field_name, field in Line._fields.iteritems():
+                                try:
+                                    value = getattr(line, field_name)
+                                except AttributeError:
+                                    continue
+                                if (value and field._type in ('many2one',
+                                            'one2one')):
+                                    vals[field_name] = value.id
+                                    vals[field_name + '.rec_name'] = \
+                                        value.rec_name
+                                else:
+                                    vals[field_name] = value
                             del vals['id']
-                            vals['amount'] = (abs(line['amount'])
+                            vals['amount'] = (abs(line.amount)
                                 - amount_to_pay)
-                            if line['amount'] < 0:
+                            if line.amount < 0:
                                 vals['amount'] = - vals['amount']
                             vals['invoice'] = None
+                            del vals['invoice.rec_name']
                             res['lines']['add'].append(vals)
-                    invoice_id2amount_to_pay[line['invoice']] = \
-                            amount_to_pay - abs(line['amount'])
+                    invoice_id2amount_to_pay[line.invoice.id] = \
+                            amount_to_pay - abs(line.amount)
         return res
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
+    @classmethod
+    def delete(cls, statements):
         # Cancel before delete
-        self.cancel(ids)
-        for statement in self.browse(ids):
+        cls.cancel(statements)
+        for statement in statements:
             if statement.state != 'cancel':
-                self.raise_user_error('delete_cancel', statement.rec_name)
-        return super(Statement, self).delete(ids)
+                cls.raise_user_error('delete_cancel', statement.rec_name)
+        super(Statement, cls).delete(statements)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('draft')
-    def draft(self, ids):
+    def draft(cls, statements):
         pass
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('validated')
-    def validate(self, ids):
-        statement_line_obj = Pool().get('account.statement.line')
-        lang_obj = Pool().get('ir.lang')
+    def validate(cls, statements):
+        Lang = Pool().get('ir.lang')
 
-        for statement in self.browse(ids):
+        for statement in statements:
             computed_end_balance = statement.start_balance
             for line in statement.lines:
                 computed_end_balance += line.amount
             if computed_end_balance != statement.end_balance:
-                lang_id, = lang_obj.search([
+                lang, = Lang.search([
                         ('code', '=', Transaction().language),
                         ])
-                lang = lang_obj.browse(lang_id)
 
-                amount = lang_obj.format(lang,
+                amount = Lang.format(lang,
                         '%.' + str(statement.journal.currency.digits) + 'f',
                         computed_end_balance, True)
-                self.raise_user_error('wrong_end_balance',
+                cls.raise_user_error('wrong_end_balance',
                     error_args=(amount,))
             for line in statement.lines:
-                statement_line_obj.create_move(line)
+                line.create_move()
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('posted')
-    def post(self, ids):
-        statement_line_obj = Pool().get('account.statement.line')
+    def post(cls, statements):
+        StatementLine = Pool().get('account.statement.line')
 
-        statements = self.browse(ids)
         lines = [l for s in statements for l in s.lines]
-        statement_line_obj.post_move(lines)
+        StatementLine.post_move(lines)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('cancel')
-    def cancel(self, ids):
-        statement_line_obj = Pool().get('account.statement.line')
+    def cancel(cls, statements):
+        StatementLine = Pool().get('account.statement.line')
 
-        statements = self.browse(ids)
         lines = [l for s in statements for l in s.lines]
-        statement_line_obj.delete_move(lines)
-
-Statement()
+        StatementLine.delete_move(lines)
 
 
 class Line(ModelSQL, ModelView):
     'Account Statement Line'
-    _name = 'account.statement.line'
-    _description = __doc__
-
+    __name__ = 'account.statement.line'
     statement = fields.Many2One('account.statement', 'Statement',
             required=True, ondelete='CASCADE')
     date = fields.Date('Date', required=True)
@@ -377,9 +364,10 @@
             },
         depends=['party', 'account', 'amount'])
 
-    def __init__(self):
-        super(Line, self).__init__()
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(Line, cls).__setup__()
+        cls._error_messages.update({
             'debit_credit_account_statement_journal': 'Please provide debit '
                 'and credit account on statement journal.',
             'same_debit_credit_account': 'Credit or debit account on '
